<?xml version="1.0" encoding="utf-8"?>
<layout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:app="http://schemas.android.com/apk/res-auto"
    xmlns:tool="http://schemas.android.com/tools">

    <data>

        <import type="android.view.View" />

        <import type="com.impaktsoft.globeup.R" />

        <import type="com.impaktsoft.globeup.bindingadapters.BindingConvert" />

        <import type="com.impaktsoft.globeup.enums.EventState" />

        <variable
            name="item"
            type="com.impaktsoft.globeup.models.EventPOJO" />

        <variable
            name="eventState"
            type="EventState" />

        <variable
            name="viewModel"
            type="com.impaktsoft.globeup.viewmodels.BaseEventsViewModel" />

    </data>

    <androidx.cardview.widget.CardView
        android:id="@+id/event_cell_carview"
        android:layout_width="match_parent"
        android:layout_height="wrap_content"
        android:layout_marginHorizontal="@dimen/activity_horizontal_margin"
        android:layout_marginTop="@dimen/activity_vertical_margin"
        app:cardCornerRadius="6dp"
        app:cardElevation="6dp">

        <LinearLayout
            android:id="@+id/eventCellView"
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:orientation="vertical">

            <LinearLayout
                android:id="@+id/event_cell_click_layout"
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:orientation="vertical">

                <ImageView
                    android:id="@+id/event_cell_image"
                    cb_imageResource="@{item.image}"
                    android:layout_width="match_parent"
                    android:layout_height="140dp"
                    android:transitionName="@string/transition_event_image" />

                <RelativeLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content">

                    <TextView
                        android:id="@+id/event_date"
                        cb_eventDate="@{item.eventDate}"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginStart="@dimen/activity_vertical_margin"
                        android:layout_marginTop="@dimen/activity_vertical_margin"
                        android:textColor="@color/red_1"
                        android:textSize="16sp"
                        tool:text="Date" />

                    <TextView
                        android:id="@+id/event_name"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_below="@id/event_date"
                        android:layout_marginStart="@dimen/activity_horizontal_margin"
                        android:text="@{item.name}"
                        android:textColor="@color/black"
                        android:textSize="@dimen/title_size"
                        android:transitionName="@string/transition_event_title"
                        tool:text="Event title">

                    </TextView>

                    <TextView
                        cb_addressLat="@{item.location.latitude}"
                        cb_addressLong="@{item.location.longitude}"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_below="@id/event_name"
                        android:layout_alignParentStart="true"
                        android:layout_marginStart="@dimen/activity_vertical_margin"
                        android:layout_marginBottom="@dimen/activity_vertical_margin"
                        android:layout_toStartOf="@id/distanceFrom"
                        android:text="@{item.desciption}"
                        android:textColor="@color/black"
                        android:textSize="@dimen/normal_size">

                    </TextView>

                    <TextView
                        android:id="@+id/distanceFrom"
                        cb_eventLocation="@{item.location}"
                        cb_scaleType="@{viewModel.getScaleType()}"
                        cb_userLocation="@{viewModel.getUserCurrentLocation()}"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_below="@id/event_name"
                        android:layout_alignParentEnd="true"
                        android:layout_marginLeft="@dimen/activity_horizontal_margin"
                        android:layout_marginRight="@dimen/activity_horizontal_margin"
                        android:textSize="@dimen/normal_size"
                        tool:text="10km">

                    </TextView>

                </RelativeLayout>


                <View
                    android:layout_width="fill_parent"
                    android:layout_height="1dp"
                    android:layout_marginLeft="@dimen/activity_horizontal_margin"
                    android:layout_marginRight="@dimen/activity_horizontal_margin"
                    android:layout_marginBottom="@dimen/activity_vertical_margin"
                    android:background="@color/colorPrimaryDark" />
            </LinearLayout>

            <RelativeLayout
                android:id="@+id/actual_event_status_layout"
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:layout_marginBottom="@dimen/activity_vertical_margin"
                android:visibility="@{BindingConvert.isHoster(eventState) ? View.VISIBLE:View.GONE }">

                <TextView
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_gravity="center_vertical"
                    android:gravity="center"
                    android:text="@string/hosted_by_you"
                    android:textAlignment="center" />

            </RelativeLayout>

            <LinearLayout
                android:id="@+id/upcming_event_status_layout"
                android:layout_width="match_parent"
                android:layout_height="60dp"
                android:layout_marginBottom="@dimen/activity_vertical_margin"
                android:orientation="horizontal"
                android:transitionName="@string/tranzition_event_options_layout"
                android:visibility="@{BindingConvert.isHoster(eventState) ? View.GONE : View.VISIBLE}">

                <RelativeLayout
                    android:layout_width="wrap_content"
                    android:layout_height="60dp"
                    android:layout_weight="1"
                    android:orientation="horizontal">

                    <LinearLayout
                        android:layout_width="wrap_content"
                        android:layout_height="match_parent"
                        android:layout_centerHorizontal="true"
                        android:onClick="@{()->viewModel.interestedForEvent(item)}"
                        android:orientation="vertical">

                        <ImageView
                            android:id="@+id/event_cell_interested_image"
                            cb_currentViewEventState="@{EventState.INTERESTED}"
                            cb_eventImageTint="@{eventState}"
                            android:layout_width="44dp"
                            android:layout_height="44dp"
                            android:layout_gravity="center"
                            app:srcCompat="@drawable/ic_interested_event" />

                        <TextView
                            android:id="@+id/event_cell_interested_text"
                            cb_currentViewEventState="@{EventState.INTERESTED}"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical"
                            android:text="@string/interested_text"
                            android:textColor="@{eventState}" />
                    </LinearLayout>
                </RelativeLayout>

                <RelativeLayout
                    android:layout_width="wrap_content"
                    android:layout_height="60dp"
                    android:layout_weight="1"
                    android:orientation="horizontal">

                    <LinearLayout
                        android:layout_width="wrap_content"
                        android:layout_height="match_parent"
                        android:layout_centerHorizontal="true"
                        android:onClick="@{()->viewModel.joinEvent(item)}"
                        android:orientation="vertical">

                        <ImageView
                            android:id="@+id/event_cell_join_image"
                            cb_currentViewEventState="@{EventState.JOINED}"
                            cb_eventImageTint="@{eventState}"
                            android:layout_width="44dp"
                            android:layout_height="44dp"
                            android:layout_gravity="center_vertical"
                            app:srcCompat="@drawable/ic_done" />

                        <TextView
                            android:id="@+id/event_cell_join_text"
                            cb_currentViewEventState="@{EventState.JOINED}"
                            android:layout_width="match_parent"
                            android:layout_height="@dimen/normal_size"
                            android:layout_gravity="center_vertical"
                            android:gravity="center"
                            android:text="@string/join"
                            android:textAlignment="center"
                            android:textColor="@{eventState}" />
                    </LinearLayout>
                </RelativeLayout>

                <RelativeLayout
                    android:layout_width="wrap_content"
                    android:layout_height="60dp"
                    android:layout_weight="1"
                    android:orientation="horizontal">

                    <LinearLayout
                        android:layout_width="wrap_content"
                        android:layout_height="match_parent"
                        android:layout_centerHorizontal="true"
                        android:onClick="@{()->viewModel.inviteToEvent(item)}"
                        android:orientation="vertical">

                        <ImageView
                            android:id="@+id/event_cell_invite_image"
                            android:layout_width="44dp"
                            android:layout_height="44dp"
                            android:layout_gravity="center_vertical"
                            app:srcCompat="@drawable/ic_share" />

                        <TextView
                            android:id="@+id/event_cell_invite_text"
                            android:layout_width="match_parent"
                            android:layout_height="@dimen/normal_size"
                            android:layout_gravity="center_vertical"
                            android:gravity="center"
                            android:text="@string/invite"
                            android:textAlignment="center"
                            android:textColor="@color/colorPrimaryDark" />
                    </LinearLayout>
                </RelativeLayout>

                <RelativeLayout
                    android:layout_width="wrap_content"
                    android:layout_height="60dp"
                    android:layout_weight="1"
                    android:orientation="horizontal"
                    android:visibility="gone">

                    <LinearLayout
                        android:layout_width="wrap_content"
                        android:layout_height="match_parent"
                        android:layout_centerHorizontal="true"
                        android:onClick="@{()->viewModel.donateForEvent(item)}"
                        android:orientation="vertical">

                        <ImageView
                            android:layout_width="44dp"
                            android:layout_height="44dp"
                            android:layout_gravity="center_vertical"
                            app:srcCompat="@drawable/ic_donate_event" />

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="@dimen/normal_size"
                            android:layout_gravity="center_vertical"
                            android:text="@string/donate_text"
                            android:textColor="@color/colorPrimaryDark" />
                    </LinearLayout>
                </RelativeLayout>


            </LinearLayout>

        </LinearLayout>

        <RelativeLayout
            android:id="@+id/eventCellLoadingView"
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            android:background="@color/white_overlay"
            android:clickable="true"
            android:focusable="true"
            android:visibility="@{viewModel.isEventModifying(item.uid) ? View.VISIBLE : View.GONE }">

            <ProgressBar
                android:layout_width="100dp"
                android:layout_height="100dp"
                android:layout_centerInParent="true" />
        </RelativeLayout>

    </androidx.cardview.widget.CardView>
</layout>
